/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.impl;

import org.xmloperator.lambda2.net.model.Cell;
import org.xmloperator.lambda2.net.model.Port;
import org.xmloperator.lambda2.net.model.Stack;

/**
 * Cell implementation. The Cell is amalgamated with its principal Port.
 */
public abstract class CellImpl extends PortImpl implements Cell {

	public CellImpl() {
		super();
		this.cell = this;
		this.portNumber = 0;
	}

	//////////////////////
	// Cell implementation
	//////////////////////

	public boolean isWireCell() {
		return false;
	}

	public boolean isEraser() {
		return false;
	}

	public boolean isBinaryCell() {
		return false;
	}

	public boolean isPentaryMultiplexor() {
		return false;
	}

	public boolean isDecoder() {
		return false;
	}

	public final Port getPrincipalPort() {
		return this;
	}

	public void collectPorts(Stack portStack) {
		portStack.push(this);
	}
}
