/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.impl;

import org.xmloperator.lambda2.net.model.Cell;
import org.xmloperator.lambda2.net.model.Eraser;
import org.xmloperator.lambda2.net.model.Port;

/**
 * Eraser implementation.
 */
public final class EraserCellImpl extends CellImpl implements Eraser {

	public EraserCellImpl() {
	}

	//////////////////////
	// Cell implementation
	//////////////////////

	public int getSymbol() {
		return SYMBOL_ERASER;
	}

	public int getSymbolArity() {
		return 0;
	}
	
	public boolean isEraser() {
		return true;
	}

	public Port getPort(int portNumber) {
		if (portNumber == 0)
			return this;
		throw new IllegalArgumentException();
	}

	public Cell cloneCell() {
		return new EraserCellImpl();
	}

	public int interact() {
		PortImpl connectedPort = this.connectedPort;
		if (connectedPort.portNumber != 0)
			throw new IllegalStateException("Not an active pair");
		CellImpl cell = connectedPort.cell;
		return cell.isEraser() ? INTERACTION_ANNIHILATION_ERASER : cell
				.interact();
	}
}