/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.impl;

import org.xmloperator.lambda2.net.model.LongStack;

/**
 * LongStack implementation.
 */
public class LongStackImpl implements LongStack {
	protected long[] stack;
	protected int size = 0;
	
	public LongStackImpl() {
		this.stack = new long[16];
	}

	public LongStackImpl(int initialCapacity) {
		if (initialCapacity <= 0)
			throw new IllegalArgumentException();
		this.stack = new long[initialCapacity];
	}

	///////////////////////////
	// LongStack implementation
	///////////////////////////
	
	public boolean isEmpty() {
		return this.size == 0;
	}

	public void push(long value) {
		if (this.size == this.stack.length) {
			long[] newStack = new long[this.stack.length << 1];
			System.arraycopy(this.stack, 0, newStack, 0, this.size);
			this.stack = newStack;
		}
		this.stack[this.size++] = value;
	}

	public long pop() {
		if (this.size == 0)
			throw new IllegalStateException();
		return this.stack[--this.size];
	}
}
