/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.impl;

import org.xmloperator.lambda2.net.model.Stack;

/**
 * Stack implementation.
 */
public class StackImpl implements Stack {
	protected Object[] stack;
	protected int size = 0;
	
	public StackImpl() {
		this.stack = new Object[16];
	}

	public StackImpl(int initialCapacity) {
		if (initialCapacity <= 0)
			throw new IllegalArgumentException();
		this.stack = new Object[initialCapacity];
	}

	///////////////////////
	// Stack implementation
	///////////////////////
	
	public boolean isEmpty() {
		return this.size == 0;
	}

	public int size() {
		return this.size;
	}
	
	public Object get(int index) {
		return this.stack[index];
	}
	
	public void push(Object object) {
		if (this.size == this.stack.length) {
			Object[] newStack = new Object[this.stack.length << 1];
			System.arraycopy(this.stack, 0, newStack, 0, this.size);
			this.stack = newStack;
		}
		this.stack[this.size++] = object;
	}

	public Object pop() {
		if (this.size == 0)
			throw new IllegalStateException();
		return this.stack[--this.size];
	}
}
