/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.impl;

import java.io.PrintStream;

import org.xmloperator.lambda2.MainTest;

/**
 * Package test.
 */
public abstract class Test {
	static final boolean ASSERTION = MainTest.ASSERTION;
	private static final boolean IS_VERBOSE = false;

	public static void main(String[] args) {
		if (test(System.out, false))
			System.out.println("All is OK");
		System.exit(0);
	}

	/**
	 * Executes some tests on the package.
	 * 
	 * @param out
	 *            the PrintStream to print results.
	 * @param isVerbose
	 *            if true then all tests have to be displayed.
	 * @return true if all is Ok.
	 */
	public static boolean test(PrintStream out, boolean isVerbose) {
		isVerbose |= IS_VERBOSE;
		boolean isOk = true;
		isOk &= LambdaNetImpl.test(out, isVerbose);
		return isOk;
	}
}
