/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.model;

/**
 * Stack of Object.
 */
public interface Stack {

	/**
	 * Returns true if this stack is empty, false elsewhere.
	 * 
	 * @return true if this stack is empty, false elsewhere.
	 */
	public boolean isEmpty();

	/**
	 * Returns the size of this stack.
	 * 
	 * @return the size of this stack.
	 */
	public int size();

	/**
	 * Returns the object of this stack with the given index.
	 * 
	 * @param index
	 *            an index (from <tt>0</tt> at root to <tt>size - 1</tt> at
	 *            top).
	 * @return the object of this stack with the given index.
	 */
	public Object get(int index);

	/**
	 * Adds a given Object to the top of this stack.
	 * 
	 * @param object
	 *            an Object. May be null.
	 */
	public void push(Object object);

	/**
	 * Pops an Object at the top of the stack and returns it.
	 * 
	 * @return the Object at the top of the stack. May be null.
	 * @throws IllegalStateException
	 *             if the stack is empty.
	 */
	public Object pop();
}