/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.term.impl;

import java.util.Map;
import java.util.Set;

import org.xmloperator.lambda2.term.model.Variable;

/**
 * Variable implementation.
 */
public class VariableImpl extends TermImpl implements Variable {

	final void addFreeVariables(Set boundVariables, Set freeVariables) {
		if (!boundVariables.remove(this))
			freeVariables.add(this);
	}

	final void toText(StringBuffer sb, int boundVariableStackSize,
			Map fromBoundVariableToName) {
		String variableName = (String) fromBoundVariableToName.remove(this);
		sb.append(variableName != null ? variableName : "f");
	}

	//////////////////////
	// Term implementation
	//////////////////////

	public final int getTermType() {
		return TYPE_VARIABLE;
	}

	public final boolean isVariable() {
		return true;
	}

	//////////////////////////
	// Variable implementation
	//////////////////////////
}