/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.term.model;

/**
 * Abstraction of a Term relatively to a set of linear variables.
 */
public interface Abstraction extends Term {

	/**
	 * Returns the body of this Abstraction.
	 * 
	 * @return the body of this Abstraction.
	 */
	public Term getBody();

	/**
	 * Returns the count of linear bound variables of this Abstraction.
	 * 
	 * @return the count of linear bound variables of this Abstraction.
	 */
	public int getBoundVariableCount();

	/**
	 * Returns the bound Variable of this Abstraction, with the given index.
	 * 
	 * @param index
	 *            an index between <tt>0</tt> and
	 *            <tt>boundVariableCount -1</tt>.
	 * @return the bound Variable of this Abstraction, with the given index.
	 */
	public Variable getBoundVariable(int index);
}
