/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.term.model;

/**
 * Application of a function to an argument.
 */
public interface Application extends Term {

	/**
	 * Returns the function of this Application.
	 * 
	 * @return the function of this Application.
	 */
	public Term getFunction();

	/**
	 * Returns the argument of this Application.
	 * 
	 * @return the argument of this Application.
	 */
	public Term getArgument();

	/**
	 * Returns the function exponent. Optional feature. Default value is
	 * <tt>1L</tt>.
	 * 
	 * @return the function exponent. Optional feature. Default value is
	 *         <tt>1L</tt>.
	 */
	public long getFunctionExponent();
}
